<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:ms="urn:schemas-microsoft-com:xslt">
  <xsl:include href="_common.xsl"/>

  <!-- Type of object for header -->
  <xsl:variable name="objectType" select="'Objects'"/>
    
  <!-- Root -->
  <xsl:template match="/DataDocumenter">
    <xsl:variable name="pathPart" select="Breadcrumbs/Breadcrumb[last()]/@src"/>
      <div data-page="{$content}/{$pathPart}{$ext}">
        <xsl:apply-templates select="Breadcrumbs"/>

        <xsl:if test="/DataDocumenter/LicenseTag">
          <h1 data-tag="{/DataDocumenter/LicenseTag}" style="display: block; font-size: 42px; color: rgba(0, 0, 0, 0.4); text-transform: uppercase; margin-bottom: -10px;"><xsl:value-of select="/DataDocumenter/LicenseTag/@type"/></h1>
        </xsl:if>
        
        <xsl:apply-templates select="Tables | Views | Functions | Procedures"/>
    </div>
  </xsl:template>


  <!-- List -->
  <xsl:template match="Tables | Views | Functions | Procedures">
    <xsl:choose>
      <xsl:when test="./*">
        <table class="table">
          <caption>
            <xsl:value-of select="$objectType"/>
          </caption>
          <thead>
            <tr>
              <th data-sort="int" style="width: 40px"> # </th>
              <th data-sort="string">Name</th>
            </tr>
          </thead>
          <tbody>
            <xsl:apply-templates select="Table | View | Function | Procedure"/>
          </tbody>
        </table>
      </xsl:when>
    </xsl:choose>
  </xsl:template>
  
  <!-- List element -->
  <xsl:template match="Table | View | Function | Procedure">
    <tr>
        <td><xsl:value-of select="OrdinalPosition"/></td>
        <td><a href="#{$content}/{Src}{$ext}" class="ajax" data-target="#right">
          <xsl:value-of select="DisplayName"/>
        </a></td>
    </tr>
  </xsl:template>

</xsl:stylesheet>