<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:ms="urn:schemas-microsoft-com:xslt">
    
    <xsl:output method="html" encoding="utf-8" doctype-system="about:legacy-compat"/>
    <xsl:variable name="content" select="'content'"/><xsl:variable name="ext" select="''"/>
    <xsl:variable name="resources" select="'resources'"/>

    <!-- Default template -->
    <xsl:template match="*"></xsl:template>

    <!-- Redirection -->
    <xsl:template match="/DataDocumenter">
      <xsl:variable name="pathPart" select="Breadcrumbs/Breadcrumb[last()]/@src"/>
        <div data-page="{$content}/{$pathPart}{$ext}">
          <xsl:call-template name="breadcrumbs"/>
          <xsl:call-template name="modules"/>
        </div>
    </xsl:template>

    <!-- Breadcrumb -->
    <xsl:template name="breadcrumbs">
    	<div id="breadcrumb">

    		<xsl:apply-templates select="Breadcrumbs/Breadcrumb"/>
    		
    	</div>
    </xsl:template>

    <xsl:template match="Breadcrumbs/Breadcrumb">
    	<xsl:variable name="icon">
			<xsl:choose>
				<xsl:when test="@type = 'Documentation'"> icon-database </xsl:when>
				<xsl:when test="@type = 'Module'"> icon-module </xsl:when>
				<xsl:when test="@type = 'Function'"> icon-function </xsl:when>
				<xsl:when test="@type = 'Procedure'"> icon-procedure </xsl:when>
				<xsl:when test="@type = 'Table'"> icon-table </xsl:when>
				<xsl:when test="@type = 'View'"> icon-view </xsl:when>
                <xsl:when test="@type = 'Folder'"> icon-folder </xsl:when>
			</xsl:choose>
		</xsl:variable>

    	<a href="#{$content}/{@src}{$ext}" class="ajax" data-target="#right"><i class="{$icon}"></i><xsl:value-of select="."/></a>
        <xsl:if test="position() != last()"> › </xsl:if>
    </xsl:template>

    <!-- Modules -->
    <xsl:template name="modules">
        <xsl:choose>
            <xsl:when test="Modules/*">
                <xsl:if test="/DataDocumenter/LicenseTag">
                    <h1 data-tag="{/DataDocumenter/LicenseTag}" style="display: block; font-size: 42px; color: rgba(0, 0, 0, 0.4); text-transform: uppercase; margin-bottom: -10px;"><xsl:value-of select="/DataDocumenter/LicenseTag/@type"/></h1>
                </xsl:if>
                
                <table class="table">
                    <caption>Modules</caption>
                    <thead>
                        <tr>
                            <th data-sort="int" style="width: 40px">#</th>
                            <th data-sort="string">Name</th>
                        </tr>
                    </thead>
                    <tbody><xsl:apply-templates select="Modules/Module"/></tbody>
                </table>
            </xsl:when>
        </xsl:choose>
    </xsl:template>

    <xsl:template match="Modules/Module">
        <tr>
            <td><xsl:number/></td>
            <td><a href="#{$content}/{Src}{$ext}" class="ajax" data-target="#right"><xsl:value-of select="Title"/></a></td>
        </tr>
    </xsl:template>

</xsl:stylesheet>